import {Character} from "../game-model/characters/Character";
import {StoreComponent} from "../../../../app/storage/StoreComponent";
import {SerializeConstants} from "./SerializeConstants";
import {ModelComponentType} from "../game-model/ModelComponentType";

export class CharacterSerializer {

  public static serializeCharacters(characters: Character[]): StoreComponent[] {
    const storedCharacters: StoreComponent[] = []
    characters.forEach(character => storedCharacters.push(this.serializeSingleCharacter(character)))
    return storedCharacters;
  }

  private static serializeSingleCharacter(character: Character): StoreComponent{
    const fileName = character.componentName
    const jsonString = JSON.stringify(character, (key, value) => {
      if(key === 'unsaved' || key === 'type') {
        return undefined
      } else {
        return value;
      }
    }, SerializeConstants.JSON_INDENT)

    return new StoreComponent(jsonString, fileName, ModelComponentType.CHARACTER);
  }
}
